<!-- todo:
    a lot of shit
    multi in input/output patterns.
    fix in ActorBuilder: guards, index variable in foreach
-->
<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  version="1.0">
    <xsl:output method="text"/>

    <xsl:template match = "Actor">
        <xsl:text>actor </xsl:text><xsl:value-of select = "@name"/>
        <xsl:if test = "TypeParDecl">
        <xsl:text> [</xsl:text>
            <xsl:apply-templates select = "TypeParDecl"/>
        <xsl:text>] </xsl:text>
        </xsl:if><xsl:text> (</xsl:text>
            <xsl:apply-templates select = "NameDecl"/>
        <xsl:text>)

        </xsl:text>
            <xsl:apply-templates select = "InputPorts/PortDecl"/>
        <xsl:text> ==&gt; </xsl:text>
            <xsl:apply-templates select = "OutputPorts/PortDecl"/>
        <xsl:text> :

        </xsl:text>
            <xsl:apply-templates select = "VarDecl" mode = "actor"/>
        <xsl:text>
        </xsl:text>
        <xsl:apply-templates select = "Action"/>
    <xsl:text>
end</xsl:text>
    </xsl:template>

    <!-- handle Type Parameter Declarations -->
    <xsl:template match = "TypeParDecl">
        <xsl:value-of select = "@name"/>
            <xsl:text> &lt; </xsl:text>
            <xsl:apply-templates select = "Type"/>
        <xsl:if test = "position() != last()">, </xsl:if>
    </xsl:template>

    <xsl:template match = "Type">
        <xsl:choose>
            <xsl:when test = "@name = 'Function'">
                <xsl:text>[</xsl:text>
                <xsl:apply-templates select = "TypePars/Type[1]"/>
                <xsl:text> --&gt; </xsl:text>
                <xsl:apply-templates select = "TypePars/Type[2]"/>
                <xsl:text>]</xsl:text>
            </xsl:when>
            <xsl:otherwise>
                <xsl:value-of select = "@name"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <!-- /handle Type Parameter Declarations -->
    <xsl:template match = "NameDecl">
        <xsl:value-of select = "Type/@name"/><xsl:text> </xsl:text><xsl:value-of select = "@name"/>
        <xsl:if test = "count(Expr) > 0">
            <xsl:text> = </xsl:text>
            <xsl:apply-templates select = "Expr"/>
        </xsl:if>
        <xsl:if test = "position() != last()">, </xsl:if>
    </xsl:template>

    <xsl:template match = "PortDecl">
        <xsl:if test = "@multi = 'yes'"><xsl:text>multi </xsl:text></xsl:if>
        <xsl:value-of select = "Type/@name"/><xsl:text> </xsl:text><xsl:value-of select = "@name"/>
        <xsl:if test = "position() != last()">, </xsl:if>
    </xsl:template>

    <xsl:template match = "VarDecl">
        <xsl:apply-templates select = "." mode = "actor"/>
    </xsl:template>

    <xsl:template match = "VarDecl" mode = "actor">
        <xsl:call-template name = "VarDeclHelp"/>
        <xsl:text>;
        </xsl:text>
    </xsl:template>


    <xsl:template match = "VarDecl" mode = "action">
        <xsl:call-template name = "VarDeclHelp"/>
        <xsl:choose>
            <xsl:when test = "position() != last()">,
            </xsl:when>
        <xsl:otherwise><xsl:text>
        </xsl:text>
        </xsl:otherwise>
        </xsl:choose>
    </xsl:template>



    <xsl:template name = "VarDeclHelp">
        <xsl:if test = "@mutable = 'yes'">mutable </xsl:if>
        <xsl:apply-templates select = "Type"/><xsl:text> </xsl:text><xsl:value-of select = "@name"/>
        <xsl:if test = "Expr">
            <xsl:text> </xsl:text>
            <xsl:if test = "@assignable = 'yes'">:</xsl:if>
            <xsl:text>= </xsl:text>
            <!-- may want to select "anything after Type"-->
            <xsl:apply-templates select = "Expr"/>
        </xsl:if>
    </xsl:template>


    <xsl:template match = "Action">
        <xsl:text>action </xsl:text>
        <xsl:apply-templates select = "InputPattern"/>
        <xsl:text> ==&gt; </xsl:text>
        <xsl:apply-templates select = "OutputPattern"/>
        <xsl:if test = "VarDecl"><xsl:text>
        var </xsl:text>
        <xsl:apply-templates select = "VarDecl" mode = "action"/>
        </xsl:if>
        <xsl:apply-templates select = "Body"/>
        <xsl:choose>
            <xsl:when test = "position() != last()"><xsl:text>
        end

        </xsl:text></xsl:when>
            <xsl:otherwise><xsl:text>
        end</xsl:text></xsl:otherwise>
        </xsl:choose>
    </xsl:template>

    <xsl:template match = "InputPattern">
        <xsl:if test = "@tag">
            <xsl:value-of select = "@tag"/>
            <xsl:text>:</xsl:text>
        </xsl:if>
        <xsl:text>[</xsl:text>
        <xsl:apply-templates select = "Var"/>
        <xsl:if test="SeqVar">
            <xsl:text> | </xsl:text><xsl:value-of select="SeqVar/@name"/>
        </xsl:if>
        <xsl:text>]</xsl:text>
        <xsl:if test = "position() != last()">, </xsl:if>
    </xsl:template>

    <xsl:template match = "OutputPattern">
        <xsl:if test = "@tag">
            <xsl:value-of select = "@tag"/>
            <xsl:text>:</xsl:text>
        </xsl:if>
        <xsl:choose>
            <xsl:when test="Expr">
                <xsl:text>[</xsl:text><xsl:apply-templates select = "Expr"/>
                <xsl:if test="Tail">
                    <xsl:text> | </xsl:text><xsl:apply-templates select="Tail/Expr"/>
                </xsl:if>
                <xsl:text>]</xsl:text>
            </xsl:when>
            <xsl:otherwise>
                <xsl:apply-templates select="Tail/Expr"/>
            </xsl:otherwise>
        </xsl:choose>
        <xsl:if test = "position() != last()">, </xsl:if>
    </xsl:template>

    <xsl:template match = "Var|Expr[@kind = 'Var']">
        <xsl:value-of select = "@name"/>
        <xsl:if test = "position() != last()">, </xsl:if>
    </xsl:template>

    <xsl:template match = "Body">
        <xsl:text>
        do
            </xsl:text>
        <xsl:apply-templates select = "*"/>
    </xsl:template>

    <xsl:template match="Expr[@kind='Application']">
        <xsl:apply-templates select = "*"/>
        <xsl:if test = "position() != last()">, </xsl:if>
    </xsl:template>


    <xsl:template match="Expr[@kind='BinOpSeq']">
        <xsl:call-template name = "OperatorOperand">
            <xsl:with-param name = "Operators" select = "Operators/Op"/>
            <xsl:with-param name = "Operands" select = "Operands/Expr"/>
        </xsl:call-template>
        <xsl:if test = "position() != last()">, </xsl:if>
    </xsl:template>

    <xsl:template name = "OperatorOperand">
        <xsl:param name = "Operators"/>
        <xsl:param name = "Operands"/>
        <xsl:choose>
            <!-- base case -->
            <xsl:when test = "count($Operators) = 0">
                <xsl:apply-templates select = "$Operands[1]"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:apply-templates select = "$Operands[1]"/>
                <xsl:text> </xsl:text>
                <xsl:value-of select = "$Operators[1]/@name"/>
                <xsl:text> </xsl:text>
                <xsl:call-template name = "OperatorOperand">
                    <xsl:with-param name = "Operands" select = "$Operands[position() > 1]"/>
                    <xsl:with-param name = "Operators" select = "$Operators[position() > 1]"/>
                </xsl:call-template>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

    <xsl:template match="Expr[@kind='If']">
        <xsl:text>if </xsl:text>
        <xsl:apply-templates select = "Expr[1]"/>
        <xsl:text> then </xsl:text>
        <xsl:apply-templates select = "Expr[2]"/>
        <xsl:text> else </xsl:text>
        <xsl:apply-templates select = "Expr[3]"/>
        <xsl:text> end</xsl:text>
        <xsl:if test = "position() != last()">, </xsl:if>
    </xsl:template>

    <xsl:template match="Expr[@kind='Lambda']">
    </xsl:template>

    <xsl:template match="Expr[@kind='Let']">
    </xsl:template>

    <xsl:template match="Expr[@kind='List']">
        <xsl:text>[</xsl:text>
        <xsl:apply-templates select = "Expr"/>
        <xsl:if test="Generator">
            <xsl:text> : </xsl:text><xsl:apply-templates select="Generator"/>
        </xsl:if>
        <xsl:if test="Tail">
            <xsl:text> | </xsl:text><xsl:apply-templates select="Tail/Expr"/>
        </xsl:if>
        <xsl:text>]</xsl:text>
    </xsl:template>

    <xsl:template match="Expr[@kind='Literal']">
        <xsl:value-of select = "."/>
        <xsl:if test = "position() != last()">, </xsl:if>
    </xsl:template>

    <xsl:template match="Expr[@kind='Map']">
    </xsl:template>

    <xsl:template match="Expr[@kind='Proc']">
    </xsl:template>

    <xsl:template match="Expr[@kind='Set']">
    </xsl:template>

    <xsl:template match="Expr[@kind='TaggedTuple']">
    </xsl:template>

    <xsl:template match="Expr[@kind='Tuple']">
        <xsl:text>(</xsl:text>
        <xsl:call-template name = "CommaExprs">
            <xsl:with-param name = "Exprs" select = "*"/>
        </xsl:call-template>
        <xsl:text>)</xsl:text>
    </xsl:template>

    <xsl:template match="Expr[@kind='UnaryOp']">
    </xsl:template>

    <xsl:template name = "CommaExprs">
        <xsl:param name = "Exprs"/>
        <xsl:choose>
            <xsl:when test = "count($Exprs) = 0"/>
            <xsl:when test = "count($Exprs) = 1">
                <xsl:apply-templates select = "$Exprs[1]"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:apply-templates select = "$Exprs[1]"/>
                <xsl:text>,</xsl:text>
                <xsl:call-template name = "CommaExprs">
                    <xsl:with-param name = "Exprs" select = "$Exprs[position() > 1]"/>
                </xsl:call-template>
            </xsl:otherwise>
        </xsl:choose>
     </xsl:template>

     <xsl:template match = "Stmt[@kind = 'Assignment']">
        <xsl:value-of select = "@name"/>
        <xsl:text> := </xsl:text>
        <xsl:apply-templates select = "Expr"/>
        <xsl:text>;
            </xsl:text>
     </xsl:template>

     <xsl:template match = "Stmt[@kind = 'Block']">
        <xsl:text>
        begin
            </xsl:text>
        <xsl:if test = "VarDecl"><xsl:text>var
            </xsl:text>
        <xsl:apply-templates select = "VarDecl" mode = "action"/>
        </xsl:if>
        <xsl:text>
            do
            </xsl:text>
        <xsl:apply-templates select = "Stmt"/>
        <xsl:text>
        end;
        </xsl:text>
    </xsl:template>


</xsl:stylesheet>
